-- Set Hive thermostat

local thermostat = '<THERMOSTAT DEVICE NAME>'
local settemp = 0

local HiveURL = 'https://api.hivehome.com/v5/'
local username = '<HIVE USERNAME>'
local password = '<HIVE PASSWORD>'
local loginhdr = '--location --data "username=' .. username .. '&password=' .. password .. '" '
local header = '--location -X PUT --data id=1 --data "temperature='
local tempcommand = '/widgets/climate/targetTemperature'
local tempUnit = '&temperatureUnit=C" '
local cookie = 'curl --cookie cookie.jar --cookie-jar cookie.jar '
local login = 'curl --cookie cookie.jar --cookie-jar cookie.jar --location --data "username=<HIVE USERNAME>&password=<HIVE PASSWORD>" https://api.hivehome.com/v5/login'

function round(num, idp)              -- Round number into manageable digits
    local mult = 10^(idp or 0)
    return math.floor(num * mult + 0.5) / mult
end

function LoginHive(self)
	login = cookie .. loginhdr .. HiveURL .. 'login'
	os.execute(login)
end

function UploadToHive(self)
	upload = cookie .. header .. settemp .. tempUnit .. HiveURL .. "users/" .. username .. tempcommand
	os.execute(upload)
end

function LogoutHive(self)
	logout = cookie .. HiveURL .. 'logout'
	os.execute(logout)
end

commandArray = {}

if devicechanged[thermostat] then
	settemp = round(otherdevices_svalues[thermostat],1)
	print ("Setpoint: " .. settemp .. " C")
	
	LoginHive()
	UploadToHive()
	LogoutHive()
	
end

return commandArray
